@cT datastream 1
@4FONT
  1
3eb zsymbol
@5FONT
$syntaxlevel 2

* A cT program sampler, demonstrating
* some of the capabilities of the cT language.
* Center for Innovation in Learning,
* Carnegie Mellon University.

define	user:		$$ variables available to user
	f: x		$$ for plotting a user function
	
	group,story:	$$ hypertext example	
	screen: save	$$ region for display of definition
	i: saved		$$ TRUE if region saved
	m: lastsel		$$ last selection that invoked hot text
	i: x1, y1, x2, y2	$$ last message box coordinates
	
	group,color:	$$ color examples@1ff   0
@1pl4006	i: Slot		$$ palette slot of varying color@1ff8000
@1pl8000	slider: S(6)	$$ adjust red, green, blue@1ff   0
@1pl4006	i: TrueColor  $$ TRUE if true color, FALSE if palette machine@
@1ff8000
@1pl8000	
	group,function:	$$ for plot a function
	m: function(4)

	group,drill:	$$ for drill example
	i: prob(5)
	i: nprob,cprob
	
	group,exit:		$$ exit button to leave sections
	button: exit
	
	group,Ncolors:
	i: Ncolors   $$ used to check for a change in color situation

unit	Initialize
@1pl4001do	setwcolor	$$ set window color
fine	500,300
font	zsans,16
rescale	TRUE,TRUE,TRUE,TRUE
icons	zicons
imain	mymain
menu	Title: jumper(0)
menu	Index Page: jumper(1)
menu	Select a Topic; Displays: jumper(2)
menu	Select a Topic; Hot Text: jumper(3)
menu	Select a Topic; Color: jumper(4)
menu	Select a Topic; Graphs: jumper(5)
menu	Select a Topic; Mouse Movement: jumper(6)
menu	Select a Topic; User Input: jumper(7)
menu	Select a Topic; Response Analysis: jumper(8)
jump	title
*
@1pl8000unit	title
@1pl4001next	index
text	0,20; zxmax,zymax
@1fs  14@1ff   1@1pl4003A cT Program Sampler@1fs8000@1ff8000
@1pl4001\
text	20,80;500,300
@1fg 3eb@0b7@1fg8000 cT is a general-purpose programming language deve@
loped in the
   Center for Innovation in Learning at Carnegie Mellon University.

@1fg 3eb@0b7@1fg8000 cT makes it easy to write modern-looking programs@
, with graphics,
   multifont text, pull-down menus, mouse clicks and drags, etc.

@1fg 3eb@0b7@1fg8000 cT programs can run @1ff   2without change@
@1ff8000 on Mac, PC, and Unix!

This program sampler demonstrates unusual capabilities of cT programs.
\
do	clickit0
*
@1pl8000unit	index
@1pl4001	i: margin = 60
back	title
next	display_title
erase			$$ remove clickit message
text	margin,70;500-margin,300
This program has examples from several areas.  Select a topic by choos@
ing from the @1ff   1Select a Topic@1ff8000 menu.

While you are working, you can always review the previous page by sele@
cting @1ff   1(Back)@1ff8000 from the first menu.

You can also change the display size by changing the size of the windo@
w.
\
do	clickit0
*
@1pl8000unit	clickit0
@1pl4001enable	touch
text	0,zymax-32; zxmax,zymax
@1ff   2@1pl4003Click the mouse anywhere on the screen
or press RETURN to continue.@1ff8000
@1pl4001\
* 
@1pl8000unit	display_title	$$  Graphics illustrations
@1pl4001back	index
next	house
do	section("DISPLAYS")
*
@1pl8000unit	house		$$ house:  filled rectangles, etc
@1pl4001	i: n
next	fancytext
back	display_title
text	15,20;102,50
@1pl4003Filled areas
@1pl4001\
box	15,15;102,42;2
if	zncolors > zyellow
	color	zyellow
else
	pattern	zpatterns,4	$$ affects solid areas such as -disk- and -fill-
endif
at	325,69
disk	30		$$ sun
mode	rewrite
pattern	zpatterns,98
if	zncolors > zgreen
.	color	zgreen,zred
endif
fill	97,165;154,108;340,108;397,165	$$ roof
pattern	zpatterns,zk(B)	$$ bricks
if	zncolors > zred
	color	zwhite,zred
else
	color	zblack,zwcolor
endif
fill	280,108;310,70	$$ chimney
fill	105,165;390,268-20	$$ body of house
pattern			$$ reset to default pattern (solid)
color	zblack,zwhite
box	280,108;310,70
box	105,165;390,248
erase	254,198 ;330,232	$$ window
if	zncolors > zblue
.	color	zblue,zgreen
endif
fill	254,198; 274,198; 264,220; 264,232; 254,232	$$ drapes
fill	330,198; 310,198; 320,220; 320,232; 330,232
erase	134,198 ;163,248	$$ door
color	zblack,zwcolor
at	157,229
disk	2		$$ door knob
box	254,198 ;330,232 	$$ window frame
box	134,198 ;163,248	$$ door frame
do	clickit
*
@1pl8000unit	fancytext
@1pl4001	i: margin = 140
next	animation
back	house
color	zwhite
fill	margin-10,20;500-margin+10,220
color	zblack
box	margin-10,20;500-margin+10,220
text	margin,30;500-margin, 220
@1pl4007cT can display @1ff   1bold text@1ff8000 and @1ff   2italic te@
xt@1ff8000.  It offers @1fs  28large print@1fs8000 and @1fsffecsmall p@
rint,@1fs8000 subscripts and superscripts:  H@1fsffec@1ff  202@1fs8000@
@1ff8000SO@1fsffec@1ff  204@1fs8000@1ff8000, a@1fsffec@1ff  402@
@1fs8000@1ff8000+b@1fsffec@1ff  402@1fs8000@1ff8000 = c@1fsffec@
@1ff  402@1fs8000@1ff8000
@1pl4001
@1ff   1@1pl4003cT can center!@1ff8000
@1pl4001
@1pl4007cT handles West European languages:  Espa@0f1a, fa@0e7ade, M@
@0fcnchen, @0c5ngstr@0f6m...
@1pl4001\
do	clickit
*
@1pl8000unit	animation
@1pl4001	i: index,incr = 4,indent = 80,from,to
next	xrotate
back	fancytext
text	indent,30; zxmax-indent,zymax
You can create icons and use them for illustrations and animations.
\
inhibit	startdraw(2)
color	,zwcolor
loop	index := 100,400, incr
	calc	from := (80/150^2)(index-incr-250)^2
		to := (80/150^2)(index-250)^2
	if	zncolors > zred
		color	zred
	endif
	move	icons:  index-incr,170+from; index,170+to; zk(F)
	if	zncolors > zmagenta 
		color	zmagenta
	endif
	move	icons:  index-incr,170-from; index,170-to; zk(F)
endloop
color	zblack
do	clickit
box	370,140;zxmax-40,200
text	370,154; zxmax-40,200
@1pl4003Repeat
Animation
@1pl4001\
do	pause
if	(370 <ztouchx < zxmax-40) & (140 < ztouchy < 200)
	jump	animation
else
	press	zk(next)
endif
*
@1pl8000unit	xrotate
@1pl4001back	animation
next	stars
rorigin	35,95
do	sailboat
at	16,110
write	A picture like this
	can be . . .
do	clickit
do	pause
fill	205,3;309,105
mode	xor
rorigin	216,97
do	sailboat
mode	write
at	221,120
write	displayed in
	inverse mode.
do	pause
rorigin	146,247
size	-1,1
rotate	45
do	sailboat	$$ draw boat
rotate	0	$$ reset -rotate-
size	1	$$ reset -size-

at	180,212
write	reversed
	& rotated.
do	pause
rorigin	372,220
size	0.8,2.4
do	sailboat	$$ draw boat
size	1
at	363,232
write	changed in size 
	& aspect ratio.
do	clickit
*
@1pl8000unit	sailboat
@1pl4001rbox	0,0; 80,-20
rdraw	60,-20; 60,-90; 10,-30; 60,-30
rat	45,-50
rcircle	8
*
@1pl8000unit	stars
@1pl4001	integer: i
back	xrotate
next	fractals
at	266,22
write	These designs are constructed
	by rotation of simple figures.
rorigin	150,150
if	zncolors > zred
	color	zred
endif
loop	i := 0, 360, 15
	rotate	i  
	rdraw	-50,0; 50,0; 0,130; -50,0
endloop
rorigin	400,150
if	zncolors > zmagenta
	color	zmagenta
endif
loop	i := 0, 330, 30
	rotate	i  
	rvector	0,0; 80,0;-34
endloop
rotate	0
do	clickit
*
@1pl8000unit	fractals		$$ recursion example
@1pl4001next	hottext_title
back	stars
text	339,63;480,192
@1ff   1Recursion@1ff8000

This fractal drawing is made with simple recursion using local variabl@
es.
\
fill	18,45;333,262
color	zwhite
do	FractArrow(175,50, 1, 0, 0)
do	clickit
*
@1pl8000unit	FractArrow(rx,ry, scale, rotate, depth)
@1pl4001	merge,global:
	f: scale, scaley, rotate
	i: rx, ry, depth
	i: maxdepth = 7	$$ maximum depth
       	i: angle = 70	$$ try  30 < angle < 140 
       	i: length = 100	$$ length of first line
       	f: ff = .65		$$ scale reduction factor
outunit	maxdepth < depth	$$ exit condition
if	depth = zblack | depth >= zncolors
	color	zwhite
else
	color	depth
endif
rorigin	rx,ry	$$ origin at current screen position
size	scale
rotate	rotate
rdraw	; 0,length      	$$ draw from current position
calc	rx := zwherex	$$ save current screen x
	ry := zwherey	$$ save current screen y
do	FractArrow (rx,ry, ff*scale, rotate+angle, depth+1)
do	FractArrow (rx,ry, ff*scale, rotate-angle, depth+1)
*
@1pl8000unit	hottext_title
@1pl4001back	fancytext
next	HotText
do	section("HOT TEXT")
*
@1pl8000unit	HotText		$$ hot text example
@1pl4001* The example involves Spanish and Italian text, with hot text@
 for English definitions.
* In addition to the unusual capabilities of hot text for this purpose@
, note the unusual
* capability of cT to handle non-English text in a machine-independent@
 way.
	merge,story:
	m: text
	edit: es
text	10,100; zxmax-10,zymax-50
@1pl4003Preparing Hot Text.....
@1pl4001\
do	ReadingText(; text)
edit	es; 10,10; zxmax-10,zymax-50; Definition; text; vscroll
focus	es
text	0,zymax-47;zxmax,zymax
@1pl4003Double click on words for definitions
@1pl4001\
do	ExitButton("EndHotText", TRUE)
calc	saved := FALSE
* The following loop watches for a change in the text selection,
* in which case any definition displayed on the screen is erased.
loop
	pause	.3,keys=touch
	if	saved & [zkey~=zk(timeup) | ~zsamemark(lastsel,zeditsel(es))]
		put	save; x1,y1
		calc	saved := FALSE
	endif
endloop
*
@1pl8000unit	EndHotText
@1pl4001jump	color_title
*
@1pl8000unit	Definition	$$ display the hot-text word definition
@1pl4001	merge, story:
	i: width, height, offset = 10
if	saved
	put	save; x1,y1
endif
* First determine the width and height of the definition:
inhibit	display
at	0,0
write	<|cr|><|s,zhotinfo(zedit)|>
calc	width := zwherex+2offset
	height := zwherey+2offset
allow	display
* Calculate the size of the surrounding box:
calc	x1 := zxmax/2-width/2
	y1 := zymax-10-height-2
	x2 := x1+width
	y2 := y1+height
* Save what is on the screen at this place:
get	save; x1,y1; x2,y2
calc	saved := TRUE
	lastsel := zeditsel(zedit)
* Display the definition:
erase	x1,y1; x2,y2
box	x1,y1; x2,y2;-2
at	x1+offset,y1+offset
show	zhotinfo(zedit)
*
@1pl8000unit	ReadingText(; text)
@1pl4001	m: text
* These Spanish and Italian texts have
* "hot text" wrapped around each word,
* containing an English translation.
string	text
@1ff   1@1pl4003Spanish Text@1ff8000
@1pl4001
@1pl4007@1ht   1Madrid@1ht8000, @1ht   2la@1ht8000 @1ht   3capital@
@1ht8000 @1ht   4de@1ht8000 @1ht   5Espa@0f1a@1ht8000, @1ht   6tiene@
@1ht8000 @1ff   2@1cl   2@1ht   7tres @1ht   8millones@1ff8000@1cl8000@
@1ht8000 @1ht   9de@1ht8000 @1ht   ahabitantes@1ht8000.  @1ht   bEst@
@0e1@1ht8000 @1ht   cen@1ht8000 @1ht   del@1ht8000 @1ht   ecentro@
@1ht8000 @1ht   fgeogr@0e1fico@1ht8000 @1ht  10de@1ht8000 @1ht  11la@
@1ht8000 @1ht  12naci@0f3n@1ht8000.
@1pl4003@1ht  13@
@4STXT
134
-1
5130
298 0 0 0 
298 135 0 0 
298 135 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@5STXT
@1ht8000
@1pl4007
@1ht  14Madrid@1ht8000 @1ht  15es@1ht8000 @1ht  16una@1ht8000 @1ht  17@
ciudad@1ht8000 @1ht  18muy@1ht8000 @1ht  19alegre@1ht8000, @1ff   2@
@1ht  1aespecialmente@1ht8000 @1ht  1bdurante@1ht8000 @1ht  1clas@
@1ht8000 @1ht  1dhoras@1ht8000 @1ht  1edel@1ht8000 @1ht  1fpaseo@
@1ff8000@1ht8000, @1ht  20que@1ht8000 @1ht  21comienza@1ht8000 @
@1ht  22m@0e1s@1ht8000 @1ht  23o@1ht8000 @1ht  24menos@1ht8000 @
@1ht  25a@1ht8000 @1ht  26las@1ht8000 @1ht  27siete@1ht8000 @1ht  28de@
@1ht8000 @1ht  29la@1ht8000 @1ht  2atarde@1ht8000.  @1ht  2bLos@
@1ht8000 @1ht  2cmadrile@0f1os@1ht8000 @1ht  2dprefieren@1ht8000 @
@1ht  2epasear@1ht8000 @1ht  2fpor@1ht8000 @1ht  30la@1ht8000 @1ht  31@
Puerta@1ht8000 @1ht  32del@1ht8000 @1ht  33Sol@1ht8000, @1ht  34por@
@1ht8000 @1ht  35el@1ht8000 @1ht  36Paseo@1ht8000 @1ht  37del@1ht8000 @
@1ht  38Prado@1ht8000, @1ht  39donde@1ht8000 @1ht  3aest@0e1@1ht8000 @
@1ht  3buno@1ht8000 @1ht  3cde@1ht8000 @1ht  3dlos@1ht8000 @1ht  3emus@
eos@1ht8000 @1ht  3fm@0e1s@1ht8000 @1ht  40importantes@1ht8000 @
@1ht  41del@1ht8000 @1ht  42mundo@1ht8000, @1ht  43y@1ht8000 @1ht  44p@
or@1ht8000 @1ht  45la@1ht8000 @1ht  46Gran@1ht8000 @1ht  47Via@1ht8000@
, @1ht  48el@1ht8000 @1ht  49centro@1ht8000 @1ht  4ateatral@1ht8000 @
@1ht  4by@1ht8000 @1ht  4ccinematogr@0e1fico@1ht8000.  @1ht  4dEsta@
@1ht8000 @1ht  4eavenida@1ht8000 @1ht  4ftermina@1ht8000 @1ht  50en@
@1ht8000 @1ht  51la@1ht8000 @1ht  52Plaza@1ht8000 @1ht  53de@1ht8000 @
@1ht  54Espa@0f1a@1ht8000, @1ht  55donde@1ht8000 @1ht  56vemos@1ht8000@
 @1ht  57un@1ht8000 @1ht  58monumento@1ht8000 @1ht  59a@1ht8000 @
@1ht  5aCervantes@1ht8000 @1ht  5bcon@1ht8000 @1ht  5clas@1ht8000 @
@1ht  5dfiguras@1ht8000 @1ht  5ede@1ht8000 @1ff   1@1ht  5fDon Quijote@
@1ff8000@1ht8000 @1ht  60y@1ht8000 @1ff   1@1ht  61Sancho Panza@
@1ff8000@1ht8000, @1ht  62protagonistas@1ht8000 @1ht  63de@1ht8000 @
@1ht  64su@1ht8000 @1ht  65gran@1ht8000 @1ht  66novela@1ht8000.  @
@1ht  67Cerca@1ht8000 @1ht  68de@1ht8000 @1ht  69la@1ht8000 @1ht  6apl@
aza@1ht8000 @1ht  6btambi@0e9n@1ht8000 @1ht  6cest@0e1n@1ht8000 @
@1ht  6ddos@1ht8000 @1ht  6eedificios@1ht8000 @1ht  6fmuy@1ht8000 @
@1ht  70altos@1ht8000:  @1ht  71el@1ht8000 @1ht  72Edificio@1ht8000 @
@1ht  73Espa@0f1a@1ht8000 @1ht  74y@1ht8000 @1ht  75la@1ht8000 @
@1ht  76Torre@1ht8000 @1ht  77de@1ht8000 @1ht  78Madrid.@1ht8000
@1pl4001

@1ff   1@1pl4003Italian Text@1ff8000
@1pl4007
@1ht  79Trento@1ht8000, @1ht  7acentro@1ht8000 @1ht  7bamministrativo@
@1ht8000 @1ht  7cimportante@1ht8000 @1ht  7de@1ht8000 @1ht  7esede@
@1ht8000 @1ht  7fdi@1ht8000 @1ht  80cospicue@1ht8000 @1ht  81industrie@
@1ht8000, @1ht  82dal@1ht8000 @1ht  83punto@1ht8000 @1ht  84di@1ht8000@
 @1ht  85vista@1ht8000 @1ht  86turistico@1ht8000 @1ht  87@0e8@1ht8000 @
@1ff   2@1cl   2@1ht  88una@1ht8000 @1ht  89delle@1ht8000 @1ht  8acitt@
@0e0@1ht8000 @1ht  8bpi@0f9@1ht8000 @1ht  8cinteressanti@1ht8000 @
@1ht  8dd'Italia@1ff8000@1cl8000@1ht8000 @1ht  8eed@1ht8000 @1ht  8fan@
che@1ht8000 @1ht  90una@1ht8000 @1ht  91delle@1ht8000 @1ht  92pi@0f9@
@1ht8000 @1ht  93visitate@1ht8000 @1ht  94per@1ht8000 @1ht  95la@
@1ht8000 @1ht  96sua@1ht8000 @1ht  97posizione@1ht8000 @1ht  98lungo@
@1ht8000 @1ht  99la@1ht8000 @1ht  9agrande@1ht8000 @1ht  9bvia@1ht8000@
 @1ht  9cdi@1ht8000 @1ht  9dcommunicazione@1ht8000 @1ht  9eche@1ht8000@
 @1ht  9fcollega@1ht8000 @1ht  a0la@1ht8000 @1ht  a1pianura@1ht8000 @
@1ht  a2veneta@1ht8000 @1ht  a3col@1ht8000 @1ht  a4Brennero@1ht8000 @
@1ht  a5e@1ht8000 @1ht  a6quindi@1ht8000 @1ht  a7col@1ht8000 @1ht  a8C@
entro@1ht  a9-Europa@1ht8000.
@1pl4003@1ht  aa@
@4STXT
134
-1
5130
298 0 0 0 
298 135 0 0 
298 135 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@5STXT
@1ht8000
@1pl4001
@1pl4007@1ht  abSituata@1ht8000 @1ht  acin@1ht8000 @1ht  aduna@1ht8000@
 @1ht  aebella@1ht8000 @1ht  afconca@1ht8000 @1ht  b0solcata@1ht8000 @
@1ht  b1dall@1ht8000'@1ht  b2Adige@1ht8000, @1ht  b3@0e8@1ht8000 @
@1ht  b4sovrastata@1ht8000 @1ht  b5ad@1ht8000 @1ht  b6ovest@1ht8000 @
@1ht  b7dalle@1ht8000 @1ht  b8alture@1ht8000 @1ht  b9di@1ht8000 @
@1ff   1@1ht  baSardagna@1ff8000@1ht8000 @1ht  bbe@1ht8000 @1ht  bcdi@
@1ht8000 @1ff   1@1ht  bdSoprasasso@1ff8000@1ht8000 @1ht  bee@1ht8000 @
@1ht  bfsi@1ht8000 @1ht  c0estende@1ht8000 @1ht  c1sulle@1ht8000 @
@1ht  c2pendici@1ht8000 @1ht  c3collinari@1ht8000 @1ht  c4ad@1ht8000 @
@1ht  c5oriente@1ht8000; @1ht  c6lontano@1ht8000 @1ht  c7si@1ht8000 @
@1ht  c8stagliano@1ht8000 @1ht  c9nettamente@1ht8000 @1ht  cai@1ht8000@
 @1ht  cbprofili@1ht8000 @1ht  ccdelle@1ht8000 @1ht  cdcime@1ht8000 @
@1ht  cealpine@1ht8000 @1ht  cftra@1ht8000 @1ht  d0cui@1ht8000 @
@1ht  d1quelle@1ht8000 @1ht  d2del@1ht8000 @1ht  d3gruppo@1ht8000 @
@1ht  d4del@1ht8000 @1ht  d5Bondone@1ht8000 @1ht  d6e@1ht8000 @1ht  d7@
l'erta@1ht8000 @1ht  d8Paganella@1ht8000.  @1ht  d9I@1ht8000 @1ht  dam@
onti@1ht8000 @1ht  dbdel@1ht8000 @1ht  dcTrentino@1ht8000 -- @1ht  ddo@
ttimamente@1ht8000 @1ht  deattrezzati@1ht8000 @1ht  dfcon@1ht8000 @
@1ht  e0mezzi@1ht8000 @1ht  e1meccanici@1ht8000 @1ht  e2di@1ht8000 @
@1ht  e3trasporto@1ht8000 -- @1ht  e4hanno@1ht8000 @1ht  e5attirato@
@1ht8000 @1ht  e6un@1ht8000 @1ht  e7forte@1ht8000 @1ht  e8afflusso@
@1ht8000 @1ht  e9di@1ht8000 @1ht  eavilleggianti@1ht8000 @1ht  ebe@
@1ht8000 @1ht  ecdi@1ht8000 @1ht  edamanti@1ht8000 @1ht  eedello@
@1ht8000 @1ht  efsport@1ht8000 @1ht  f0della@1ht8000 @1ht  f1montagna@
@1ht8000 @1ht  f2e@1ht8000 @1ht  f3costituiscono@1ht8000 @1ht  f4una@
@1ht8000 @1ht  f5cornice@1ht8000 @1ht  f6naturale@1ht8000 @1ht  f7al@
@1ht8000 @1ht  f8vario@1ht8000 @1ht  f9quadro@1ht8000 @1ht  fadella@
@1ht8000 @1ht  fbcitt@0e0@1ht8000.
@1pl4001\
*
@1pl8000unit	precolor_title
@1pl4001do	setwcolor
jump	color_title
*
@1pl8000unit	color_title		$$ color examples
@1pl4001next	CheckColor
back	fractals
do	section("COLOR")
*
@1pl8000unit	CheckColor
@1pl4001	merge,color:@1ff   0
@1pl4007	i: palsize@1ff8000
@1pl4001next	graph_title
calc	Slot := zmagenta  $$ use magenta slot temporarily@1ff   0
@1pl4007	TrueColor := FALSE
palette	Slot,100,0,0,0,0,TRUE
if	zncolors < 2	$$ nothing but black and white available
	text	0,89;zxmax,150
This section requires
a color display.
\
	box	121,60;390,164;3
	pause	keys=all,touch@1ff8000
@1pl4001	do	clickit@1ff   0
@1pl4007elseif	~zreturn
	* Could be because this is a true color machine; check:
	sysinfo	palette size, palsize
	if	palsize = 0  $$ indicates true color machine
		calc	TrueColor := TRUE
		palette	Slot,100,0,0@1ff8000
@1pl4001		do	RGB	$$ color is OK@1ff   0
@1pl4007	else
		text	0,89;zxmax,150
This monitor has color, but
cT cannot modify the palette.
\@1ff8000
@1pl4001		do	clickit
	endif
else
	do	RGB	$$ color is OK
endif
*
@1pl8000unit	RGB	$$ experiment with RGB and HSV color descriptions
@1pl4001back	precolor_title
color	zwhite,zblack
wcolor	zblack
erase
@1ff   0@1pl4007do	CreateSliders
at	295,20
write	@1fsffecUse the mouse to adjust the red,
	green, and blue content of the colored 
	area.  Or adjust the hue, saturation, 
	and value (brightness).  

	Note that reducing the saturation 
	"dilutes" the color by mixing in some 
	white (which is an equal mixture of 
	red, green, and blue).@1fs8000@1ff8000
@1pl4001do	ExitButton("prestripe1",TRUE)
*
@1ff   0@1pl4006unit	CreateSliders   $$ create 3 RGB and 3 HSV sliders
@1pl4007	merge,color:
	integer: nn
	float: hue, saturation, value
	marker: color
do	InitSlider(1,60,35,100,"R")
text	0,43;55,300
@1fsffec@1pl4005100%@1fs8000
@1pl4007\
text	0,124;55,300
@1fsffec@1pl40050%@1fs8000
@1pl4007\
do	InitSlider(2,80,35,0,"G")
do	InitSlider(3,100,35,0,"B")
gethsv	100, 0, 0; hue, saturation, value  $$ convert red to hsv
do	InitSlider(4,60,175,hue,"H")
loop	nn := 1, 7
	calc	\nn-2 \color:="red" \color:="magenta" \color:="blue"
		\color:="cyan" \color:="green" \color:="yellow"
		\color:="red"
	text	0,184+13(nn-1); 55,300
@1fsffec@1pl4005<|s,color|>@1fs8000
@1pl4007\
endloop
do	InitSlider(5,167,175,saturation,"S")
text	0,184; 162,300
@1fsffec@1pl4005saturated@1fs8000
@1pl4007\
text	0,223; 162,300
@1fsffec@1pl4005pastel@1fs8000
@1pl4007\
text	0,260; 162,300
@1fsffec@1pl4005grey@1fs8000
@1pl4007\
do	InitSlider(6,275,175,value,"V")
text	0,184; 270,300
@1fsffec@1pl4005bright@1fs8000
@1pl4007\
text	0,260; 270,300
@1fsffec@1pl4005dark@1fs8000
@1pl4007\
color	Slot
do	ShowNewColor  $$ display initial color (red)
color	zwhite@1ff8000
@1pl4001*
@1ff   0@1pl4006unit	UpdatePalette(id)	$$ update all color sliders
@1pl4007	merge,color:
	i: id
	f: red,green,blue,hue,saturation,value
if	id <= 3		$$ user changed RGB, must adjust HSV sliders
	if	TrueColor
		color	rgb, zvalue(S(1)),zvalue(S(2)),zvalue(S(3))
		do	ShowNewColor
	else
		$$ -rgb- command instantly changes color on screen:
		rgb	Slot, zvalue(S(1)),zvalue(S(2)),zvalue(S(3))
	endif
	gethsv	zvalue(S(1)),zvalue(S(2)),zvalue(S(3)); hue, saturation, value
	slider	reset, S(4); value, hue/3.6
	slider	reset, S(5); value, saturation
	slider	reset, S(6); value, value
else			$$ user changed HSV, must adjust RGB sliders
	if	TrueColor
		color	hsv, 3.6zvalue(S(4)), zvalue(S(5)), zvalue(S(6))
		do	ShowNewColor
	else
		hsv	Slot, 3.6zvalue(S(4)), zvalue(S(5)), zvalue(S(6))
	endif
	getrgb	3.6 zvalue(S(4)), zvalue(S(5)), zvalue(S(6)); red, green, blue
	slider	reset, S(1); value, red
	slider	reset, S(2); value, green
	slider	reset, S(3); value, blue
endif
*
@1pl4006unit	InitSlider(id, xx, yy, value, label)  $$ create a color s@
lider
@1pl4007	merge,color:
	i: id, xx, yy
	f:  value
	m: label
rorigin	xx, yy
rtext	0,-16;10,0
@1pl4003<|s,label|>
@1pl4007\
rslider	S(id);0,0; 10,110; UpdatePalette(id); value, value
*
@1pl4006unit	ShowNewColor
@1pl4007fill	122,20;285,145@1ff8000
@1pl4001*
@1pl8000unit	prestripe1
@1ff   0@1pl4007palette	zmagenta,100,0,100,0,0  $$ restore magenta@
@1ff8000
@1pl4001do	setwcolor
jump	stripe1
*
@1pl8000unit	stripe1  $$ fade from red to white
@1pl4001back	CheckColor
do	stripe(TRUE)
pause	keys=all,touch
jump	stripe2
*
@1pl8000unit	stripe2  $$ fade through rainbow of hues
@1pl4001	merge,Ncolors:
back	stripe1
do	stripe(FALSE)
pause	keys=all,touch
jump	graph_title
*
@1pl8000unit	stripe(reds)
@1pl4001	i: reds  $$ TRUE if fade from red to white, else rainbow
	f: y, dy, dsat, dhue
	i: NCOL=50  $$ number of colors in fade
	i: i, nc, slot(NCOL), R(NCOL), G(NCOL), B(NCOL)
* To avoid noticeable breaks, plot to nearest pixel.
calc	nc := zncolors-8
if	nc > NCOL
	calc	nc := NCOL
endif
if	nc < 8
	at	58,89
	write	This example requires
		more colors than are
		available.
	box	50,86;205,140
	do	clickit
	outunit
endif
calc	dsat := 100/(nc-1)
	dhue := 300/(nc-1)
	dy := zypixels/nc
	y := 100
text	0,60;zxmax,zymax
@1pl4003Create a palette of <|s,nc|> colors
@1pl4001\
loop	i:= 1,nc
	calc	slot(i) := 7+i
	if	reds
		getrgb	0, 100-(i-1)*dsat, 100; R(i), G(i), B(i)
	else
		getrgb	(i-1)*dhue, 100, 100; R(i), G(i), B(i)
	endif
endloop
newpal	slot, R, G, B
loop	i := 1, nc
	color	slot(i)
	fill	0, y; zxmax, y := y+1
endloop
do	mymain
if	reds
	text	0,180;zxmax,zymax
@1pl4003Fade from red through pink to white
@1pl4001\
else
	text	0,180;zxmax,zymax
@1pl4003"Rainbow" fade from red to magenta
@1pl4001\
endif
text	0,zymax-20; zxmax,zymax
@1ff   2@1pl4003Click or press RETURN to continue.@1ff8000
@1pl4001\
***
@1pl8000unit	graph_title
@1pl4001back	stripe2
next	graphbars
do	section("GRAPHS")
*
@1pl8000unit	graphbars
@1pl4001next	all_quadrants
back	graph_title
at	24,26
write	You can establish graphing
	axes, label the axes, and
	make displays using these
	graphing coordinates.
gorigin	250,200
axes	-200, -40; 200, 160
scalex	20
scaley	40
labelx	5,1
labely	10,5
* labely 10,5 means "place a major tick mark
* every 10 units and a minor tick mark every 5 units"
if	zncolors > zred
	color	zred
endif
gat	5,32
write	Hello there! 
gat	9,30
gcircle	5
gdraw	7,20; 11,20; 9,7; 7,20
gvector	18,0; 18,40
vbar	-17,20; 3,-10; 12,-15
pattern	zpatterns,8
hbar	-10,15; -2,35
pattern
do	clickit
*
@1pl8000unit	all_quadrants
@1pl4001next	ClippedFunctionPlot
back	graphbars
text	79,140;425,168
@1ff   1@1pl4003Graphing axes can be in any quadrant.@1ff8000
@1pl4001\
gorigin	285, 110       $$ 1st quadrant
axes	140, 80
scalex	.4
scaley	6
labelx	.1
labely	2,1
*
gorigin	220, 110        $$ 2nd quadrant
axes	-140, 0; 0, 80
scalex	-.4
scaley	6
labelx	.1
labely	2,1
*
gorigin	220, 190        $$ 3rd quadrant
axes	-140, -80; 0, 0
scalex	-.4
scaley	-6
labelx	.1
labely	2,1
*
gorigin	285,190        $$ 4th quadrant 
axes	0, -80; 140, 0
scalex	.4
scaley	-6
labelx	.1
labely	2,1
do	clickit
*
@1pl8000unit	ClippedFunctionPlot
@1pl4001	float: x
next	PolarPlot
back	all_quadrants
* a clipped plot
text	1,20;510,61
@1fs  14@1ff   1@1pl4003A function plot@1fs8000@1ff8000
@1pl4001\
gorigin	80,210
axes	0,-50; 360,150
scalex	360 
scaley	3
labelx	90,45,1  $$ 1 means extend major tick marks
labely	1,0.5,1 
gclip	0,-1; 360,3
if	zncolors > zred
	color	zred
endif
inhibit	startdraw
loop	x := 0, 360, 5 
	gdraw	;x, .01x +sin(4x*DEG)
endloop
clip		$$ remove the clipping
do	clickit
*
@1pl8000unit	PolarPlot
@1pl4001	float: angle
back	ClippedFunctionPlot
next	semilog
at	36,28
write	Polar coordinates
	(radius-angle)
at	308,52;496,152
write	@1fsffecPoints are "radius, angle"
	instead of the more common 
	"x,y" of cartesian coordinates.@1fs8000

gorigin 	253,190
axes	-170,0;170,170
polar	TRUE  $$ turn on polar mode
scalex	10
scaley	10
labelx	5,1
labely	5,1
inhibit	startdraw
if	zncolors > zred
	color	zred
endif
loop	angle := 0.1, 1080.1, 15
	gdraw	; angle/200, angle
endloop
if	zncolors > zblue
.	color	zblue
endif
gvector	0,0; 5,45
gvector	5,45; 8,135
gvector	8,135; 0,0
polar	FALSE   $$ turn off polar mode
do	clickit
*
@1pl8000unit	semilog
@1pl4001next	PickAFunction
back	PolarPlot
menu	Pick a Function
at	195,43
write	Semi-Log Graph
gorigin	122,230
axes	250,150
scalex	10
lscaley	100
labelx	1,10,2  $$ 2 means extend all tick marks
labely	10,10,2
if	zncolors > zred
.	color	zred
endif
gdraw	2,2; 6,20; 10,2
gvector	5,2; 8,60; 15
do	clickit
*
@1pl8000unit	PickAFunction
@1pl4001	merge,function:
next	mouse_movement_title
back	semilog
do	plotsetup
do	fillfunction
menu	Pick a Function; <|s,function(1)|>: plotfunction(1)
menu	Pick a Function; <|s,function(2)|>: plotfunction(2)
menu	Pick a Function; <|s,function(3)|>: plotfunction(3)
menu	Pick a Function; Enter Your Own Function: yourfunction
menu	Pick a Function; -: jumper(-1)
menu	Pick a Function; Clear Screen: clearplot
*
@1pl8000unit	plotsetup
@1pl4001box
gorigin	248,164
axes	-200,-100; 200,100
scalex	100
scaley	50
labelx	50,10
labely	25,5
at	10,10
write	Choose from the @1ff   1Pick a Function@1ff8000 menu.
do	clickit
*
@1pl8000unit	plotfunction(temp)
@1pl4001	merge,global:
	merge,function:
	f: y
	i: temp
erase	10,25; 300,50
at	10,25
write	Now plotting:  <|s, function(temp)|>
clip	0,0; zxmax,zymax
inhibit	startdraw
if	zncolors > zmagenta
	color	\temp-2 \ zred \ zmagenta \ zblue \ zblack
endif
loop	x := -100,100,1
	compute	y, function(temp)
	gdraw	; x,y
endloop
do	mymain
*
@1pl8000unit	yourfunction
@1pl4001	merge,function:
	f: ty
do	mymain
erase	10,25; 300,50
at	10,25
write	Enter a function of x:
arrow	zwherex+10,zwherey; 500,zwherey+50
	at	15,40
	write	 and press RETURN
	allow	blanks
	enable	touch
ok	zjcount = 0
	jump	mouse_movement_title
compute	ty
ok	zreturn
	specs	nookno
	calc	function(4) := zcopy(zarrowm)
at	20,55
write	Cannot understand your function.
endarrow
erase	10,25; 500,55
do	plotfunction(4)
*
@1pl8000unit	fillfunction
@1pl4001	merge,function:
set	function := "(x^2 + 3x - 2500)/100","xcos(x/4)", "x"
*
@1pl8000unit	clearplot
@1pl4001erase
do	plotsetup
*
@1pl8000unit	mouse_movement_title
@1pl4001next	MouseDrawing
back	PickAFunction
menu	Pick a Function
do	section("MOUSE MOVEMENT")
*
@1pl8000unit	MouseDrawing
@1pl4001back	mouse_movement_title
at	10,10;478,150
write	Click the mouse button to draw connected line segments.
	- OR -
	Hold down the mouse button to draw a smooth line.
pause	keys = touch(left:down; right:down),all
do	ExitButton("EndMouseDrawing",TRUE)
if	zncolors > zred
	color	zred
endif
dot	ztouchx,ztouchy
loop
	pause	keys = touch(left:down,move),all
	if	zkey = zk(left:down)		$$ connected line segments
		outloop	425<ztouchx<500 & 250<ztouchy<300
		if	zncolors > zmagenta
			color	zred
		endif
		draw	;ztouchx,ztouchy
	elseif	zkey = zk(left:move)		$$ smooth line
		if	zncolors > zmagenta
			color	zmagenta
		endif
		draw	;ztouchx,ztouchy
	endif
endloop
do	EndMouseDrawing
*
@1pl8000unit	EndMouseDrawing
@1pl4001jump	user_input_title
*
@1pl8000unit	user_input_title
@1pl4001back	MouseDrawing
next	SlithyToves
do	section("USER INPUT")
*
@1pl8000unit	SlithyToves	$$ try out cut and paste
@1pl4001	m: mystring
back	user_input_title
font	zserif,16
text	40,31;436,200
When you are entering a response, the options @1ff   1Cut, Copy and Pa@
ste@1ff8000 are available from the first menu.

To use these options, select a region of the text below by dragging th@
e mouse.  Then use the menu.

Try it now:
\
do	ExitButton("EndSlithyToves",TRUE)
font	zsans,16
string	mystring
Twas brillig and the slithy toves
\
arrow	85,zwherey+30;379,250
	calc	zarrowm := mystring
specs	nookno
judge	exit
endarrow
*
@1pl8000unit	EndSlithyToves
@1pl4001jump	response_analysis_title
*
@1pl8000unit	response_analysis_title
@1pl4001back	SlithyToves
next	RubberBaby
do	section("RESPONSE ANALYSIS")
*
@1pl8000unit	RubberBaby
@1pl4001back	response_analysis_title
next	PigLatinFun
text	40,20;460,126
cT automatically gives feedback to the user, which tells how his or he@
r response differs from the desired response.  Type this phrase, @
@1ff   2making some mistakes@1ff   1, THEN PRESS RETURN:@1ff8000  

	rubber baby buggy bumpers
\
do	ExitButton("EndRubberBaby",FALSE)
arrow	99,zwherey+30;441,240
erase	97,176;494,245
answer	rubber baby buggy bumpers
no
	at	144,150; 500,245
	write	Spelling errors are shown in @1ff   2italics.@1ff8000
		Unrecognized words are marked in @1ff   1bold@1ff8000.
		A word out of order is preceded by @1ff   1<-@1ff8000 .
		The location of a missing word is shown by  @1ff   1[] @1ff8000.
endarrow
*
@1pl8000unit	EndRubberBaby
@1pl4001jump	PigLatinFun
*
@1pl8000unit	PigLatinFun	$$ main unit.  Get a phrase and convert it
@1pl4001	m: nextW,whiteS,punct
	i: lCode
calc	whiteS := " "		$$ white space
	punct := "!$()':;,.?"		$$ punctuation
back	RubberBaby
text	0,40;zxmax,zymax-50
@1fs  14@1ff   1@1pl4003PIG  LATIN  FUN@1fs8000@1ff8000
@1pl4001\
at	40,80
write	Enter a phrase, then press RETURN:
do	ExitButton("EndPigLatinFun",TRUE)
arrow	80,110; zxmax,200
calc	nextW := zstart(zarrowm)	$$ initialize the position of the "next @
word"
at	60,150; 440,300
loop				$$ look through the whole phrase
	do	LexSent(;nextW,whiteS,punct,lCode) $$ get lexical code of next wor@
d
	outloop	lCode = 3		$$ end of phrase
	if	lCode = 0		$$ if we have a word (not something else)
		do	ToPig(;nextW)	$$ make it pig latin
	endif
endloop
show	zarrowm		$$ show our result
specs	nookno
endarrow
**********
@1pl8000unit	EndPigLatinFun
@1pl4001jump	InitializeDrill
**********
@1pl8000unit	ToPig(;word)	$$ convert a word (in the marker word) to pi@
g latin
@1pl4001	m: word,firstC,middle,vowels,checkC,wEnd
	i: isVowel, firstUp
calc	vowels := "eaoiuEAOIU"		$$ vowels, more or less in frequency orde@
r
outunit	word = zempty		$$ don't do anything if word is empty

calc	firstC := zstart(word)		$$ firstC starts at word begin
	checkC := znext(firstC)		$$ start checkC

* take care of upper case of first letter
do	IsUpper(checkC;firstUp)	$$ is the first char upper case?
if	firstUp
	do	ToLower(;checkC)	$$ if so, make old first char lower case
endif
loop	zprecede(zstart(checkC),zend(word))
	do	OneOf(;vowels,checkC,isVowel)  $$ is it a vowel?
	if	isVowel
* for the benefit of the calc at the end of the loop, change checkC to@
 have no length
		calc	checkC := zstart(checkC)
		outloop	$$ we've found a vowel, we're done
	endif
	calc	checkC := znext(checkC)	$$ advance checkC
endloop
* at this point, the end of checkC is at boundary between consonants &@
 vowels
calc	firstC := zextent(firstC,checkC)	$$ firstC spans the first chunk @
of consonants

* now we need to get the middle portion of the word
calc	wEnd := zend(word)  $$ mark the word end
if	zprevious(wEnd) = "a"  $$ back up if last char is an a (so don't ge@
t aay)
	calc	wEnd := zstart(zprevious(wEnd))
endif
calc	middle := zextent(zend(firstC),wEnd)
replace	word,middle+firstC+"ay"
if	firstUp
	do	ToUpper(;word)
endif

**********
@1pl8000unit	LexSent(;nextP,whiteS,punct,lCode)   $$ perform lexical a@
nalysis on phrase
@1pl4001	m: nextP,whiteS,punct,checkC
	i: lCode,nextCode
calc	nextP := zend(nextP)		$$ start looking after end of nextP
calc	checkC := znext(nextP)

if	checkC = zempty  $$ no further chars in the base text
	calc	lCode := 3
	outunit
endif

do	CharType(;checkC,whiteS,punct,lCode)   $$ what kind of char is firs@
t char?
calc	checkC := znext(checkC)	$$ advance checkC
loop	checkC ~= zempty	$$ scan through base text (checkC empty at end)
	do	CharType(;checkC,whiteS,punct,nextCode)
	outloop	nextCode ~= lCode	$$ hit something different
	calc	checkC := znext(checkC) $$ advance checkC
endloop
calc	nextP := zextent(nextP,zstart(checkC))	$$ make up lexical chunk

*****************************

@1pl8000unit	CharType(;cc,whiteS,punct,lCode)   $$ get character type @
of cc
@1pl4001	m: cc,whiteS,punct
	i: lCode,isIt

do	OneOf(;whiteS,cc,isIt)
if	isIt  $$ character is white space
	calc	lCode := 1
	outunit
endif

do	OneOf(;punct,cc,isIt)
if	isIt  $$ character is punctuation
	calc	lCode := 2
	outunit
endif

* otherwise:
calc	lCode := 0 $$ "normal"

**********

@1pl8000unit	OneOf(;set,test,isIn)  	$$ check if test is a member of s@
et, result returned in isIn
@1pl4001	m: test,set
	i: isIn
calc	isIn := (zsearch(set,zfirst(test)) != zempty)

************
@1pl8000unit	IsUpper(theC;isUp)	$$ check to see if first char in theC @
is upper case
@1pl4001	m: theC
	i: isUp
calc	isUp := FALSE
if	"A" <= zfirst(theC) <= "Z"
	calc	isUp := TRUE
endif

*************************************
@1pl8000unit	IsLower(theC;isLow)	$$ check to see if first char in theC@
 is lower case
@1pl4001	m: theC
	i: isLow
calc	isLow := FALSE
if	"a" < = zfirst(theC) <= "z"
	calc	isLow := TRUE
endif

***************************************
@1pl8000unit	ToUpper(;theC)  	$$ change character to upper case
@1pl4001	m: theC, firstC
	i: aCode
calc	firstC := zfirst(theC)  $$ only work on first char
do	IsLower(firstC;aCode)  $$ to make sure
if	aCode
	calc	aCode := zcode(firstC)
		aCode := aCode - 32
	replace	firstC,zchar(aCode)
endif

*******************************************
@1pl8000unit	ToLower(;theC)  	$$ change character to lower case
@1pl4001	m: theC, firstC
	i: aCode
calc	firstC := zfirst(theC)  $$ only work on first char
do	IsUpper(firstC;aCode)  $$ to make sure
if	aCode
	calc	aCode := zcode(firstC)
		aCode := aCode + 32
	replace	firstC,zchar(aCode)
endif
*
@1pl8000unit	InitializeDrill
@1pl4001	merge, drill:
	i:ii
calc	nprob:=3			$$ number of problems in drill
loop	ii:=1,nprob
	calc	prob(ii):=ii	$$ problem array
endloop
next	Drill
back	PigLatinFun	
text	109,59
The program can look for words or numbers.
It can be instructed to ignore extra words.

In the next drill you will be asked for a number.
Try various responses.  

When you are doing the drill you might try
such things as "2+.5+.5" or "sqrt(9)".
Or you might try typing the word "three".
\
do	clickit
*
@1pl8000unit	Drill
@1pl4001	merge, drill:
back	InitializeDrill
loop	nprob>0				$$ continue until no problems are left
	erase
	randu	cprob,nprob		$$ select a problem from pool
	do	\prob(cprob)\x\x\fig1\fig2\fig3	$$ display figure
	do	problem(prob(cprob))		$$ ask question
	do	\nprob>0\pressreturn\\
endloop
text	0,240;499,299
@1ff   1@1pl4003All Done!@1ff8000
@1pl4001\
next	TheEnd
do	clickit
*
@1pl8000unit	pressreturn
@1pl4001text	0,270; zxmax,zymax
@1pl4003Press RETURN for the next problem.
@1pl4001\
enable	touch
do	pause
*
@1pl8000unit	problem(quesno)
@1pl4001	i: quesno
	m: num, word, simple
calc	\quesno\\\num := "2"\num := zempty\num := "3"
calc	\quesno\\\simple := "2+2"\simple := "2+1"\simple := "3+2"
calc	\quesno\\\word := "four"\word := "three"\word := "five"
at	380,20
write	@1fsffec@1ff   2Try things like:@1ff   0
	   <|s,simple|>@1ff8000
	   1+1+<|s,num|>cos(0)
	   It has <|s,word|> sides.@1fs8000
at	77,150
write	How many sides does this figure have?
arrow	123,203;400,250
specs	okextra, okcaps
ansv	\quesno\\\4\3\5		$$ matches expressions such as 3+1
	do	remover
answer	\quesno\\\[four 4]\[three 3]\[five 5]		$$ matches "Maybe it is @
4"
	do	remover
no
	do	wrong(quesno)
endarrow
*
@1pl8000unit	fig1		$$ rectangle
@1pl4001pattern	zpatterns,5
if	zncolors > zblue
	color	zblue
endif
fill	148,40;306,131
do	mymain
pattern
*
@1pl8000unit	fig2		$$ triangle
@1pl4001pattern	zpatterns,8
if	zncolors > zmagenta
	color	zmagenta
endif
fill	150,25;150,135;308,135
do	mymain
pattern
*
@1pl8000unit	fig3		$$ pentagon
@1pl4001if	zncolors > zblue
	color	zblue
endif
fill	170,57; 215,16; 281,68; 243,125; 188,125
do	mymain
*
* Utility routines

@1pl8000unit	remover		$$ remove a problem from pool
@1pl4001	merge,drill:
calc	prob(cprob):=prob(nprob)	$$ replace current prob with last prob
	nprob:=nprob-1		$$ decrement number of probs in pool
*
@1pl8000unit	wrong(quesno)
@1pl4001	i: quesno
	marker: sideword
calc	\quesno-2\sideword:="Four"\sideword:="Three"\sideword:="Five"
write	\zntries\zntries=<|s,zntries|>\zntries=<|s,zntries|>\Try countin@
g the sides.\<|s,sideword|> sides.
*
@1pl8000unit	TheEnd
@1pl4001text	0,80; zxmax,zymax
@1pl4003Use the @1ff   1Select a Topic@1ff8000 menu
to look at any of the examples again

or

Choose @1ff   1Quit Running@1ff8000 from the first menu
to leave this program.
@1pl4001\
*
@1pl8000unit	section(title)
@1pl4001	m: title
	i: width
at	200,115
circle	70
at	300,115
circle	70
font	zsans,30
inhibit	display
at	0,0
show	title
calc	width := (zwherex+60)/2
allow	display
color	,zwhite
erase	250-width,78;250+width,152
do	mymain
box	250-width,78;250+width,152;3
text	0,103; zxmax,zymax
@1ff   1@1pl4003<|s,title|>@1ff8000
@1pl4001\
font
do	clickit
*
@1pl8000unit	mymain
@1pl4001	merge,Ncolors:
rgb	  $$ no more reserved/modifiable colors
* Check for control-panel change of zncolors, or need to restore syste@
m palette:
if	zncolors ~= Ncolors@1ff   0
@1ff8000	do	setwcolor
	erase	$$ must reset the screen
else
	do	setwcolor  $$ wcolor may have been changed
endif
clip
size	1
rotate	0
color	zblack,zwcolor
clrkey
*
@1pl8000unit	setwcolor
@1pl4001	merge,Ncolors:
calc	Ncolors := zncolors
wcolor	\ Ncolors > zcyan \ zcyan \ zwhite
*
@1pl8000unit	clickit
@1pl4001do	mymain  $$ restore colors
enable	touch
text	0,zymax-20; zxmax,zymax
@1ff   2@1pl4003Click or press RETURN to continue.@1ff8000
@1pl4001\
*
@1pl8000unit	pause
@1pl4001pause	keys=all,touch
*
@1pl8000unit	ExitButton(exitunit, onright)
@1pl4001* onright = TRUE if button placed in lower right corner, else @
lower left corner.
	merge,exit:
	m: exitunit
	i: onright
if	onright
	button	exit; 395,265; 495,290; (exitunit); "Click to go on"
else
	button	exit; 5,265; 105,290; (exitunit); "Click to go on"
endif
*
@1pl8000unit	jumper(temp)
@1pl4001	i: temp
menu	Pick A Function
rgb
do	setwcolor
jump	\temp\\title\index
	\display_title\hottext_title\color_title\graph_title
	\mouse_movement_title\user_input_title
	\response_analysis_title
*
@
@4HOTT
251
24
10
7
2
5
3
5
8
2
11
7
2
11
6
12
2
10
6
36
24
2
8
4
4
11
10
6
14
5
14
16
4
17
4
2
4
2
14
15
2
10
18
15
16
6
16
5
10
6
14
3
5
11
4
14
30
5
8
3
2
15
7
4
9
14
5
3
5
10
5
3
11
6
10
3
15
4
6
16
2
10
13
2
5
5
6
1
8
2
32
4
14
7
2
47
3
36
12
2
3
5
5
4
6
10
13
4
9
3
19
4
10
11
17
5
3
10
5
2
24
31
6
14
9
3
21
2
12
10
8
5
2
4
11
2
3
6
6
4
11
8
3
4
3
6
4
7
10
5
3
8
5
3
12
9
2
13
4
8
3
5
24
8
23
3
2
10
7
6
35
8
2
1
9
6
8
6
13
7
9
8
4
6
7
2
21
3
2
23
3
10
7
9
6
5
8
4
8
16
9
16
3
8
6
7
6
5
5
5
6
5
6
18
3
10
9
3
9
6
30
11
9
4
5
10
2
9
4
9
1
6
4
2
14
3
2
6
8
5
6
11
3
16
1
5
7
7
6
7
6
4
@cT datastream 1
Madrid, capital of Spainthe (fem.)capitalofSpainhasthreemillionsofinha@
bitants(it) isinthe (masc.)centergeographicalofthe (fem.)nationa touri@
st carriage typical of MadridMadrid, capital of Spainisa (fem.)cityver@
ygay, livelyespeciallyduringthe (fem. pl.)hoursof the (masc.)"walking @
around"thatbegins, commencesmoreorlessatthe (fem. pl.)seven (o'clock)o@
fthe (fem.)afternoon, eveningthe (masc. pl.)people of Madridpreferto w@
alk, to passalongthe (fem.)portalof the (masc.)sunalongthe (masc.)walk@
of the (masc.)the Prado, a famous art museumwherethere isoneofthe (mas@
c. pl.)museumsmostimportantof the (masc.)worldandalongthe (fem.)grandw@
aythe (masc.)centertheatricalandcinematographicthisavenueends, termina@
tesinthe (fem.)plaza, squareofSpainwherewe seeamonumenttoCervantes, au@
thor of Don Quixotewiththe (fem. pl.)figuresofDon Quixote, main charac@
ter of Cervantes' novelandSancho Panza, Don Quixote's sidekickprotagon@
istsofhisgreatnovelnearof, tothe (fem.)plaza, squarealsothere aretwobu@
ildings, edificesveryhigh, tallthe (masc.)building, edificeSpainandthe@
 (fem.)towerofMadrid, capital of SpainTrent, a city in northern Italyc@
enteradministrativeimportantandseat (home, location)ofconsiderableindu@
striesfrom thepointofviewtouristicalisoneof thecitiesmostinterestingof@
 Italyandalsooneof themostvisitedbecause of(the)itspositionalongthegre@
at, grandroad, wayofcommunicationthatconnectstheplainVeneto (region of@
 Italy)with theBrenner (mountain pass)andsowith (the)CentralEuropea to@
urist carriage typical of Trentsituatedinabeautifulhollowfurrowedby th@
eAdige (river)(it) isdominatedto (the)westby theheightsofSardagna (a m@
ountain)andofSoprasasso (a mountain)andit, itselfextendsalong theslope@
shillyto (the)eastfar awaythey, themselvesstand outsharply, clearlythe@
profilesof thesummitsalpineamongwhichthoseof thegroupof theBondone (mo@
untain)andthe ruggedPaganellathemountainsof theTrentino (region around@
 Trent)excellentlyfurnishedwithmeansmechanicaloftransporthaveattracted@
astrongflowofholiday-makersandofloversof (the)sportof themountain(s)an@
dconstitute, formaframenaturalfor thevariedpictureof thecity@cT end
@
@5HOTT
@cT end
